// File:  ADTStack\ArrayStackDemo.java

/**
 * Realization of a Stack ADT
 * 
 * @author Bary W Pollack
 * @version Jan. 2, 2001 - 19:00 PST
 */

// Provides a simple demonstration of using the Stack class

public class ArrayStackDemo {

    static final int LTH = 5;

    public static void main(String[] args) {
        System.out.println();
        System.out.println("Array Stack Demo");
        System.out.println();

        ArrayStack stack = new ArrayStack();
        stack.create(LTH);

        try {
            // Force an exception by going one too far...
            for (int i = 0; i < LTH + 1; i++) {
                stack.push(new NItem(11 + i));
                System.out.println("size=" + stack.size() + "  " + stack);
            }
        } catch (StackException e) {
            System.out.println(e);
        }

        System.out.println(); System.out.print("AS display: ");
        stack.display();
        System.out.println("isFull=" + stack.isFull() + "  stack top=" + stack.peek());

        System.out.println("size=" + stack.size() + "   " + stack);
        stack.pop();
        System.out.println("size=" + stack.size() + "   " + stack);
        stack.pop();
        System.out.println("size=" + stack.size() + "   " + stack);
        System.out.println("isFull=" + stack.isFull() + "  stack top=" + stack.peek());
        
        stack.popAll();
        System.out.println("isEmpty=" + stack.isEmpty() + "  stack: " + stack);

        System.out.println();
        System.out.println("End Array Stack Demo");
        System.out.println();
    }

}

/* ..... Execution Output .....

Array Stack Demo

size=1  11
size=2  12, 11
size=3  13, 12, 11
size=4  14, 13, 12, 11
size=5  15, 14, 13, 12, 11

******************** BACKTRACE ********************
StackException.java:46  from StackException.<init>()
ArrayStack.java:38  from ArrayStack.push()
ArrayStackDemo.java:27  from ArrayStackDemo.main()
******************** EXCEPTION ********************
StackException: stack full (5)

AS display: 15, 14, 13, 12, 11
isFull=true  stack top=15
size=5   15, 14, 13, 12, 11
size=4   14, 13, 12, 11
size=3   13, 12, 11
isFull=false  stack top=13
isEmpty=true  stack: 

End Array Stack Demo

..... End Execution Output ..... */
